# PackageInfo

Это маленькая библиотека для получения информации о пакете.

Довольно часто при создании приложений на oscript нам необходимо выводить информацию о нашем приложении. (Версию, автора и тд и тп) Эта библиотека как раз для этого.

## Пример использования

```bsl
#Использовать packageinfo

Функция ВерсияПриложения() Экспорт

    // Указываем путь до packagedef с информацией о приложении.
    ПутьКМанифесту = ОбъединитьПути(ТекущийСценарий().Каталог, "..", "packagedef");

    ОписаниеПакета = Новый ИнформацияОПакете(ПутьКМанифесту);

    Возврат СтрШаблон("Версия приложения <%1>", ОписаниеПакета.Версия());
КонецФункции
```

## Публичный интерфейс

### Свойства

* Функция `Свойства()`: Возвращает структуру всех свойств пакета.

Так-же реализовано получение отдельных свойств:

* Функция `Версия()`: Возвращает версию пакета.
* Функция `Описание()`: Возвращает описание пакета.
* Функция `Имя()`: Возвращает имя пакета.
* Функция `Автор()`: Возвращает автора пакета.
* Функция `АдресАвтора()`: Возвращает адрес автора пакета.
* Функция `ВерсияМанифеста()`: Возвращает версию манифеста пакета.
* Функция `ВерсияСреды()`: Возвращает версию среды пакета.
* Функция `ТочкаВхода()`: Возвращает точку входа пакета.
* Функция `Задачи()`: Возвращает задачи пакета.

### Зависимости

Получение информации о зависимостях пакета

* Функция `Зависимость(ИмяПакета)`: Возвращает зависимость пакета по имени.
* Функция `Зависимости()`: Возвращает таблицу всех зависимостей пакета.

### Файлы

Информация о включаемых файлах пакета

* Функция `ВключаемыеФайлы()`: Возвращает включаемые в пакет файлы.
* Функция `ИсполняемыеФайлы()`: Возвращает исполняемые файлы пакета.

### Модули (Классы и модули)

Информация о реализуемых классах и модулях пакета

* Функция `ВсеМодулиПакета()`: Возвращает все классы и модули пакета.

* Функция `Модули()`: Возвращает модули пакета.
* Функция `Классы()`: Возвращает классы пакета.

### Описание пакета

* Функция `ОписаниеПакета()`: Возвращает ОписаниеПакета.
